;*********************************************
;*********** (c) 2001 Radek Pinc *************
;*********** Reseni soustavy 3x3 *************
;*********************************************

                ; Start of data segment

                .data
                ;                

Result:         .space          4

X1:             .space          4
X2:             .space          4
X3:             .space          4

Matrix:         .byte           10,0,0
                .byte           0,10,0
                .byte           0,0,10

		;               3.03,2.02,1.01

RSide:          .byte           3,2,1
                      
                .text
                
Start:

; --- Load -----------------------------------------------------------------

                lbu             r5,Matrix+4	; Load
                lbu             r9,Matrix+8	; Load
                lbu             r6,Matrix+7	; Load
                lbu             r8,Matrix+5	; Load
                lbu             r7,Matrix+2	; Load

; --- D --------------------------------------------------------------------

		mult		r14,r5,r9	; D
		mult		r15,r6,r8	; D

                lbu             r4,Matrix+1	; Load
                lbu             r1,Matrix+0	; Load
                lbu             r2,Matrix+3	; Load

		mult		r16,r6,r7	; D
		mult		r17,r4,r9	; D
		
		sub		r14,r14,r15	; D
                lbu             r3,Matrix+6	; Load
                lbu             r11,RSide+0	; LOAD RSide

		mult		r18,r4,r8	; D
		mult		r19,r5,r7	; D

		sub		r16,r16,r17	; D
                lbu             r12,RSide+1	; LOAD RSide
                lbu             r13,RSide+2	; LOAD RSide

		mult		r20,r14,r1	; Dx
		mult		r30,r16,r2	; Dx

		sub		r18,r18,r19	; D
		add		r31,r0,1	; 1
                movi2fp         f31,r31		; 1

		mult		r31,r18,r3	; Dx
		mult		r21,r14,r11	; D1x

		add		r20,r20,r30	; D
                cvti2f          f31,f31		; 1
		;

		mult		r10,r16,r12	; D1x
		mult		r14,r18,r13	; D1x

		add		r20,r20,r31	; D
                movi2fp         f0,r20		; 1/D
                cvti2f          f20,f0		; 1/D


; --- D1 -------------------------------------------------------------------

		mult		r24,r12,r9	; D2
		mult		r25,r13,r8	; D2

		add		r21,r21,r10	; D1
		add		r21,r21,r14	; D1
		divf		f0,f31,f20	; 1/D


; --- D2 -------------------------------------------------------------------

		mult		r26,r13,r7	; D2
		mult		r27,r11,r9	; D2

		sub		r24,r24,r25	; D2
                movi2fp         f1,r21		; x=D1
		;

		mult		r28,r11,r8	; D2
		mult		r29,r12,r7	; D2

		sub		r26,r26,r27	; D2
		;
		;

		mult		r22,r24,r1	; D2x
		mult		r30,r26,r2	; D2x
		
		sub		r28,r28,r29	; D2
		;
		;

		mult		r31,r28,r3	; D2x
		mult		r14,r5,r13	; D3

		add		r22,r22,r30	; D2
                cvti2f          f21,f1		; x=D1
		;

		mult		r15,r6,r12	; D3
		multf		f1,f21,f0	; x=D1*(1/D)

		add		r22,r22,r31	; D2
                movi2fp         f2,r22		; y=D2
		;

;-----------------------
; --- D3 --------------------------------------------------------------------

		mult		r16,r6,r11	; D3
		mult		r17,r4,r13	; D3

		sub		r14,r14,r15	; D3
                cvti2f          f22,f2		; y=D2
		;

		mult		r18,r4,r12	; D3
		mult		r19,r5,r11	; D3

		sub		r16,r16,r17	; D3
		;
		;

		mult		r23,r14,r1	; D3x
		mult		r10,r16,r2	; D3x

		sub		r18,r18,r19	; D3
		;
		;

		mult		r14,r18,r3	; D3x
		multf		f2,f22,f0	; y=D2*(1/D)

		add		r23,r23,r10	; D3
		add		r23,r23,r14	; D3
                movi2fp         f3,r23		; z=D3
                cvti2f          f23,f3		; z=D3

		multf		f3,f23,f0	; z=D3*(1/D)

; --- Srore ----------------------------------------------------------------

                sf              X1,f1		; STORE1
                sf              X2,f2		; STORE2
                sf              X3,f3		; STORE3

End:

